<?php
/**
 * Filename: _upgrade.php
 * Created : Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 * Copyright 2017 - Andy Christian S. Loyola <acl20032003@gmail.com> (http://AndysDesigns.Net)
 *
 * Skype: andy_christian_loyola_
 * Yahoo: andz_christian
 * GTalk: acl20032003@gmail.com
 */
defined('_IN_MAIN_MODULE') or die ('ACCESS DENIED');

class sbpUpgrade {
	var $fs;

	var $pluginDir;
	var $preserveZip;

	function __construct() {
		global $wp_filesystem;

		if (!$wp_filesystem) {
			include_once (ABSPATH .'wp-admin/includes/file.php');
			WP_Filesystem();
		}

		$this->fs           = $wp_filesystem;
		$this->pluginDir    = ABSPATH .'wp-content/plugins/';
		$this->preserveZip  = false;
	}

	function downloadPlugin($url, $path) {
		$curl = @curl_init($url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$data = curl_exec($curl);
		curl_close($curl);

		if (!$this->fs->put_contents($path, $data, 0755)) {
			return false;
		}

		return true;
	}

	function unpackPlugin($target) {
		if (class_exists('ZipArchive')) {
			$zip    = new ZipArchive();
			$file   = $zip->open($target);
			if ($file === true) {
				$zip->extractTo($this->pluginDir);
				$zip->close();

				if ($this->preserveZip === false) {
					unlink($target);
				}

				return true;
			}
			else {
				return false;
			}
		}
		else {
			$dir = '';
			_unzip_file_pclzip($target, $this->pluginDir , $dir);
		}
	}

	function activatePlugin($installer) {
		$active = get_option('active_plugins');
		$plugin = plugin_basename($installer);

		if (!in_array($plugin, $active)) {
			$active[] = $plugin;
			sort($active);

			do_action('activate_plugin', trim($plugin));
			update_option('active_plugins', $active);

			do_action('activate_'. trim($plugin));
			do_action('activated_plugin', trim($plugin));
		}

		return null;
	}

	function getPlugins($plugins) {
		if (0 != count($plugins)) {
			if (is_dir($this->pluginDir .'__MACOSX')) {
				$this->fs->rmdir($this->pluginDir .'__MACOSX');
			}

			foreach ($plugins as $plugin) {
				$dloadUrl       = $plugin['path'];
				$dloadLocation  = $this->pluginDir . $plugin['name'] .'.zip';

				$this->downloadPlugin($dloadUrl, $dloadLocation);
				$this->unpackPlugin($dloadLocation);
				$this->activatePlugin($plugin['install']);
			}
		}

		die ('finished');
	}

	function install() {
		$plugins = array(
			array(
				'name'      => trim(strip_tags($_POST['slugs'])),
				'path'      => trim(strip_tags($_POST['path'])),
				'install'   => trim(strip_tags($_POST['install']))
			)
		);
		$this->getPlugins($plugins);
	}
}